n, m, k = map(int, input().split())

def dfs(graph, start, depth, visited = None):
    if depth <= 0:
        return visited

    if visited is None:
        visited = set()

    n = graph[start]
    visited.add(start)

    for v in n:
        if v not in visited:
            dfs(graph, v, depth -1, visited)

    return visited


def bfs(graph, start, depth):
    vis = set()
    tovis = set([start])
    for _ in range(depth):
        nextto = vis^tovis
        tovis = set()
        if len(nextto) == 0:
            break
        for i in nextto:
            tovis = tovis.union(graph[i])
        vis = vis.union(nextto)

    return vis



# a: dest,
graph = {i:[] for i in range(1, n+1)}
s = set()


for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

for _ in range(k):
    p, h = map(int, input().split())
    s = s.union(dfs(graph, p, h+1))
    #s = s.union(bfs(graph, p, h+1))

print(len(s))
print(*sorted(s))